ARG rpi_10_git_image="registry.gitlab.com/gitlab-org/gitlab-omnibus-builder/builders/rpi_10_git:latest"
ARG rpi_10_cmake_image="registry.gitlab.com/gitlab-org/gitlab-omnibus-builder/builders/rpi_10_cmake:latest"
ARG rpi_10_awscli_image="registry.gitlab.com/gitlab-org/gitlab-omnibus-builder/builders/rpi_10_awscli:latest"

FROM ${rpi_10_git_image} as git
FROM ${rpi_10_cmake_image} as cmake
FROM ${rpi_10_awscli_image} as awscli

FROM balenalib/rpi-raspbian:buster as builder

# Install required packages
RUN apt-get update -q \
  && DEBIAN_FRONTEND=noninteractive apt-get install -yq --no-install-recommends \
      build-essential \
      autoconf \
      automake \
      autopoint \
      zlib1g-dev \
      byacc \
      clang \
      git \
      gcc \
      g++ \
      libclang-dev \
      libssl-dev \
      libyaml-dev \
      libffi-dev \
      libkrb5-dev \
      libreadline-dev \
      libgdbm-dev \
      libncurses5-dev \
      llvm-dev \
      make \
      bzip2 \
      curl \
      ca-certificates \
      locales \
      openssh-server \
      libcurl4-openssl-dev \
      libexpat1-dev \
      gettext \
      libz-dev \
      fakeroot \
      ccache \
      distcc \
      unzip \
      apt-transport-https \
      gnupg \
      pkg-config \
      python3

RUN echo "en_US.UTF-8 UTF-8" > /etc/locale.gen
RUN locale-gen en_US.UTF-8
ENV LANG en_US.UTF-8
ENV LANGUAGE en_US:en
ENV LC_ALL en_US.UTF-8

RUN update-ca-certificates -f

# Include git from builder image
COPY --from=git /usr/local/bin/git* /usr/local/bin/
COPY --from=git /usr/local/share/git-core/ /usr/local/share/git-core/
COPY --from=git /usr/local/libexec/git-core/ /usr/local/libexec/git-core/

<%= Snippets.new(include: %w[versions]).populate %>

COPY --from=cmake /usr/local/bin/cmake /usr/local/bin/
COPY --from=cmake /usr/local/bin/cpack /usr/local/bin/
COPY --from=cmake /usr/local/bin/ctest /usr/local/bin/
COPY --from=cmake /usr/local/share/cmake-${CMAKE_MINOR_VERSION}/ /usr/local/share/cmake-${CMAKE_MINOR_VERSION}/


# Include awscli from builder image
COPY --from=awscli /tmp/awscli.zip /tmp/
RUN unzip -qd /tmp/ /tmp/awscli.zip \
  && /tmp/aws/install \
  && aws --version

<%= Snippets.new(exclude: %w[versions git cmake awscli], platform: 'armv6l').populate %>

FROM balenalib/rpi-raspbian:buster
MAINTAINER GitLab Inc. <support@gitlab.com>
COPY --from=builder / /
